> For the complete documentation index, see [llms.txt](https://developer.barchart.com/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://developer.barchart.com/getting-started/streaming-snapshot-types.md).

# Streaming Snapshot Types

Openfeed supports `REAL_TIME_SNAPSHOT` and `DELAYED_SNAPSHOT`. Both operate the same way. The service determines whether the data is real-time or delayed.

Set a snapshot service type and the interval for data delivery. See the `SubscriptionRequest.Request` message for additional details.

Snapshot service is currently available only for symbol subscriptions.

The following message flow shows a 15-second real-time snapshot subscription.

### Real-time snapshot subscription example

```protobuf
Sending: subscriptionRequest {
  token: "b35720bb-0788-4d4f-b170-4701c8204301"
  service: REAL_TIME_SNAPSHOT
  requests {
    symbol: "^EURUSD"
    subscriptionType: TRADES
    snapshotIntervalSeconds: 15
  }
}

subscriptionResponse {
  status {
    result: SUCCESS
    service: REAL_TIME_SNAPSHOT
  }
  symbol: "^EURUSD"
  marketId: 8663698093865741069
  channelId: 13
  subscriptionType: TRADES
}

instrumentDefinition {
  marketId: 8663698093865741069
  instrumentType: FOREX
  vendorId: "FOREX"
  symbol: "^EURUSD"
  exchangeCode: "FOREX"
  recordCreateTime: 1631133721587
  recordUpdateTime: 1631133721587
  timeZoneName: "America/Chicago"
  channel: 13
  priceFormat {
    denominator: 100000
    subDenominator: 1
  }
  priceDenominator: 1000000
  quantityDenominator: 1
  symbols {
    vendor: "Barchart"
    symbol: "^EURUSD"
  }
  subscriptionSymbol: "^EURUSD"
}

// Initial MarketSnapshot

marketSnapshot {
  marketId: 8663698093865741069
  transactionTime: 1634155017627648000
  marketSequence: 8434383
  tradeDate: 20211013
  totalChunks: 1
  currentChunk: 1
  symbol: "^EURUSD"
  service: REAL_TIME_SNAPSHOT
  instrumentStatus {
    tradingStatus: OPEN
    tradeDate: 20211013
  }
  bbo {
    bidPrice: 1159400
    bidOriginator: "SURF:LDN"
    offerPrice: 1159700
    offerOriginator: "SURF:LDN"
  }
  open {
    price: 1152969
  }
  high {
    price: 1159713
  }
  low {
    price: 1152657
  }
  last {
    tradeDate: 20211013
    price: 1159443
    quantity: 1
  }
  volume {
    volume: 165788
  }
  numberOfTrades {
    numberTrades: 165788
  }
  monetaryValue {
    value: 19065620
  }
  previousSession {
    tradeDate: 20211012
    open {
      price: 1155223
    }
    high {
      price: 1157013
    }
    low {
      price: 1152427
    }
    last {
      tradeDate: 20211012
      price: 1152974
      quantity: 1
    }
    volume {
      volume: 144627
    }
    settlement {
      tradeDate: 20211012
      price: 1152974
    }
    numberOfTrades {
      numberTrades: 144627
    }
    monetaryValue {
      value: 16632105
    }
    prevSettlement {
      tradeDate: 20211011
      price: 1155255
    }
  }
}

// MarketSnapshot 15 Seconds Later

marketSnapshot {
  marketId: 8663698093865741069
  transactionTime: 1634155034763987000
  marketSequence: 8434429
  tradeDate: 20211013
  totalChunks: 1
  currentChunk: 1
  symbol: "^EURUSD"
  service: REAL_TIME_SNAPSHOT
  instrumentStatus {
    tradingStatus: OPEN
    tradeDate: 20211013
  }
  bbo {
    bidPrice: 1159370
    bidOriginator: "BNPF:PAR"
    offerPrice: 1159400
    offerOriginator: "BNPF:PAR"
  }
  open {
    price: 1152969
  }
  high {
    price: 1159713
  }
  low {
    price: 1152657
  }
  last {
    tradeDate: 20211013
    price: 1159393
    quantity: 1
  }
  volume {
    volume: 165809
  }
  numberOfTrades {
    numberTrades: 165809
  }
  monetaryValue {
    value: 19068035
  }
  previousSession {
    tradeDate: 20211012
    open {
      price: 1155223
    }
    high {
      price: 1157013
    }
    low {
      price: 1152427
    }
    last {
      tradeDate: 20211012
      price: 1152974
      quantity: 1
    }
    volume {
      volume: 144627
    }
    settlement {
      tradeDate: 20211012
      price: 1152974
    }
    numberOfTrades {
      numberTrades: 144627
    }
    monetaryValue {
      value: 16632105
    }
    prevSettlement {
      tradeDate: 20211011
      price: 1155255
    }
  }
}

...
```


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://developer.barchart.com/getting-started/streaming-snapshot-types.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
